diff --git a/src/backend/access/common/reloptions.c b/src/backend/access/common/reloptions.c
index 609329bb21..d0bc120ecc 100644
--- a/src/backend/access/common/reloptions.c
+++ b/src/backend/access/common/reloptions.c
@@ -382,7 +382,33 @@ static relopt_int intRelOpts[] =
 		},
 		-1, 0, 1024
 	},
-
+	{
+		{
+			"compresslevel",
+			"Level of page compression.",
+			RELOPT_KIND_HEAP | RELOPT_KIND_BTREE | RELOPT_KIND_HASH | RELOPT_KIND_GIN | RELOPT_KIND_GIST | RELOPT_KIND_SPGIST,
+			ShareUpdateExclusiveLock
+		},
+		0, -127, 127
+	},
+	{
+		{
+			"compress_chunk_size",
+			"Size of chunk to store compressed page.",
+			RELOPT_KIND_HEAP | RELOPT_KIND_BTREE | RELOPT_KIND_HASH | RELOPT_KIND_GIN | RELOPT_KIND_GIST | RELOPT_KIND_SPGIST,
+			AccessExclusiveLock
+		},
+		BLCKSZ / 2, BLCKSZ / 16, BLCKSZ / 2
+	},
+	{
+		{
+			"compress_prealloc_chunks",
+			"Number of prealloced chunks for each block.",
+			RELOPT_KIND_HEAP | RELOPT_KIND_BTREE | RELOPT_KIND_HASH | RELOPT_KIND_GIN | RELOPT_KIND_GIST | RELOPT_KIND_SPGIST,
+			ShareUpdateExclusiveLock
+		},
+		0, 0, 15
+	},
 	/* list terminator */
 	{{NULL}}
 };
@@ -507,6 +533,17 @@ static relopt_enum_elt_def viewCheckOptValues[] =
 	{(const char *) NULL}		/* list terminator */
 };
 
+/* values from compressTypeOption */
+relopt_enum_elt_def compressTypeOptValues[] =
+{
+	/* no value for NOT_SET */
+	{"none", PAGE_COMPRESSION_NONE},
+	{"pglz", PAGE_COMPRESSION_PGLZ},
+	{"lz4", PAGE_COMPRESSION_LZ4},
+	{"zstd", PAGE_COMPRESSION_ZSTD},
+	{(const char *) NULL}		/* list terminator */
+};
+
 static relopt_enum enumRelOpts[] =
 {
 	{
@@ -542,6 +579,17 @@ static relopt_enum enumRelOpts[] =
 		VIEW_OPTION_CHECK_OPTION_NOT_SET,
 		gettext_noop("Valid values are \"local\" and \"cascaded\".")
 	},
+	{
+		{
+			"compresstype",
+			"Compression type (none, pglz, lz4 or zstd).",
+			RELOPT_KIND_HEAP | RELOPT_KIND_BTREE | RELOPT_KIND_HASH | RELOPT_KIND_GIN | RELOPT_KIND_GIST | RELOPT_KIND_SPGIST,
+			AccessExclusiveLock
+		},
+		compressTypeOptValues,
+		PAGE_COMPRESSION_NONE,
+		gettext_noop("Valid values are \"none\", \"pglz\", \"lz4\" and \"zstd\".")
+	},
 	/* list terminator */
 	{{NULL}}
 };
@@ -1882,7 +1930,15 @@ default_reloptions(Datum reloptions, bool validate, relopt_kind kind)
 		{"vacuum_index_cleanup", RELOPT_TYPE_ENUM,
 		offsetof(StdRdOptions, vacuum_index_cleanup)},
 		{"vacuum_truncate", RELOPT_TYPE_BOOL,
-		offsetof(StdRdOptions, vacuum_truncate)}
+		offsetof(StdRdOptions, vacuum_truncate)},
+		{"compresstype", RELOPT_TYPE_ENUM,
+		offsetof(StdRdOptions, compress) + offsetof(PageCompressOpts, compresstype)},
+		{"compresslevel", RELOPT_TYPE_INT,
+		offsetof(StdRdOptions, compress) + offsetof(PageCompressOpts, compresslevel)},
+		{"compress_chunk_size", RELOPT_TYPE_INT,
+		offsetof(StdRdOptions, compress) + offsetof(PageCompressOpts, compress_chunk_size)},
+		{"compress_prealloc_chunks", RELOPT_TYPE_INT,
+		offsetof(StdRdOptions, compress) + offsetof(PageCompressOpts, compress_prealloc_chunks)}
 	};
 
 	return (bytea *) build_reloptions(reloptions, validate, kind,
diff --git a/src/backend/access/gin/ginutil.c b/src/backend/access/gin/ginutil.c
index 6df7f2eaeb..523c18e149 100644
--- a/src/backend/access/gin/ginutil.c
+++ b/src/backend/access/gin/ginutil.c
@@ -610,7 +610,15 @@ ginoptions(Datum reloptions, bool validate)
 	static const relopt_parse_elt tab[] = {
 		{"fastupdate", RELOPT_TYPE_BOOL, offsetof(GinOptions, useFastUpdate)},
 		{"gin_pending_list_limit", RELOPT_TYPE_INT, offsetof(GinOptions,
-															 pendingListCleanupSize)}
+															 pendingListCleanupSize)},
+		{"compresstype", RELOPT_TYPE_ENUM,
+		offsetof(GinOptions, compress) + offsetof(PageCompressOpts, compresstype)},
+		{"compresslevel", RELOPT_TYPE_INT,
+		offsetof(GinOptions, compress) + offsetof(PageCompressOpts, compresslevel)},
+		{"compress_chunk_size", RELOPT_TYPE_INT,
+		offsetof(GinOptions, compress) + offsetof(PageCompressOpts, compress_chunk_size)},
+		{"compress_prealloc_chunks", RELOPT_TYPE_INT,
+		offsetof(GinOptions, compress) + offsetof(PageCompressOpts, compress_prealloc_chunks)}
 	};
 
 	return (bytea *) build_reloptions(reloptions, validate,
diff --git a/src/backend/access/gist/gistutil.c b/src/backend/access/gist/gistutil.c
index d4bf0c7563..cc255024ab 100644
--- a/src/backend/access/gist/gistutil.c
+++ b/src/backend/access/gist/gistutil.c
@@ -922,7 +922,15 @@ gistoptions(Datum reloptions, bool validate)
 {
 	static const relopt_parse_elt tab[] = {
 		{"fillfactor", RELOPT_TYPE_INT, offsetof(GiSTOptions, fillfactor)},
-		{"buffering", RELOPT_TYPE_ENUM, offsetof(GiSTOptions, buffering_mode)}
+		{"buffering", RELOPT_TYPE_ENUM, offsetof(GiSTOptions, buffering_mode)},
+		{"compresstype", RELOPT_TYPE_ENUM,
+		offsetof(GiSTOptions, compress) + offsetof(PageCompressOpts, compresstype)},
+		{"compresslevel", RELOPT_TYPE_INT,
+		offsetof(GiSTOptions, compress) + offsetof(PageCompressOpts, compresslevel)},
+		{"compress_chunk_size", RELOPT_TYPE_INT,
+		offsetof(GiSTOptions, compress) + offsetof(PageCompressOpts, compress_chunk_size)},
+		{"compress_prealloc_chunks", RELOPT_TYPE_INT,
+		offsetof(GiSTOptions, compress) + offsetof(PageCompressOpts, compress_prealloc_chunks)}
 	};
 
 	return (bytea *) build_reloptions(reloptions, validate,
diff --git a/src/backend/access/hash/hashutil.c b/src/backend/access/hash/hashutil.c
index 32822dbb6b..c6362d0a2b 100644
--- a/src/backend/access/hash/hashutil.c
+++ b/src/backend/access/hash/hashutil.c
@@ -277,6 +277,14 @@ hashoptions(Datum reloptions, bool validate)
 {
 	static const relopt_parse_elt tab[] = {
 		{"fillfactor", RELOPT_TYPE_INT, offsetof(HashOptions, fillfactor)},
+		{"compresstype", RELOPT_TYPE_ENUM,
+		offsetof(HashOptions, compress) + offsetof(PageCompressOpts, compresstype)},
+		{"compresslevel", RELOPT_TYPE_INT,
+		offsetof(HashOptions, compress) + offsetof(PageCompressOpts, compresslevel)},
+		{"compress_chunk_size", RELOPT_TYPE_INT,
+		offsetof(HashOptions, compress) + offsetof(PageCompressOpts, compress_chunk_size)},
+		{"compress_prealloc_chunks", RELOPT_TYPE_INT,
+		offsetof(HashOptions, compress) + offsetof(PageCompressOpts, compress_prealloc_chunks)}
 	};
 
 	return (bytea *) build_reloptions(reloptions, validate,
diff --git a/src/backend/access/heap/vacuumlazy.c b/src/backend/access/heap/vacuumlazy.c
index b802ed247e..96ec5dda3f 100644
--- a/src/backend/access/heap/vacuumlazy.c
+++ b/src/backend/access/heap/vacuumlazy.c
@@ -59,6 +59,7 @@
 #include "storage/bufmgr.h"
 #include "storage/freespace.h"
 #include "storage/lmgr.h"
+#include "storage/page_compression.h"
 #include "tcop/tcopprot.h"
 #include "utils/lsyscache.h"
 #include "utils/memutils.h"
@@ -444,7 +445,8 @@ heap_vacuum_rel(Relation rel, VacuumParams *params,
 	vacrel->consider_bypass_optimization = true;
 	vacrel->do_index_vacuuming = true;
 	vacrel->do_index_cleanup = true;
-	vacrel->do_rel_truncate = (params->truncate != VACOPTVALUE_DISABLED);
+	vacrel->do_rel_truncate = (params->truncate != VACOPTVALUE_DISABLED) &&
+							  (rel->rd_locator.compressOpt.algorithm == PAGE_COMPRESSION_NONE);
 	if (params->index_cleanup == VACOPTVALUE_DISABLED)
 	{
 		/* Force disable index vacuuming up-front */
@@ -2807,7 +2809,7 @@ lazy_cleanup_one_index(Relation indrel, IndexBulkDeleteResult *istat,
  */
 static bool
 should_attempt_truncation(LVRelState *vacrel)
-{
+{ 
 	BlockNumber possibly_freeable;
 
 	if (!vacrel->do_rel_truncate || vacrel->failsafe_active ||
diff --git a/src/backend/access/nbtree/nbtutils.c b/src/backend/access/nbtree/nbtutils.c
index ff260c393a..f8f3555d9e 100644
--- a/src/backend/access/nbtree/nbtutils.c
+++ b/src/backend/access/nbtree/nbtutils.c
@@ -2115,7 +2115,15 @@ btoptions(Datum reloptions, bool validate)
 		{"vacuum_cleanup_index_scale_factor", RELOPT_TYPE_REAL,
 		offsetof(BTOptions, vacuum_cleanup_index_scale_factor)},
 		{"deduplicate_items", RELOPT_TYPE_BOOL,
-		offsetof(BTOptions, deduplicate_items)}
+		offsetof(BTOptions, deduplicate_items)},
+		{"compresstype", RELOPT_TYPE_ENUM,
+		offsetof(BTOptions, compress) + offsetof(PageCompressOpts, compresstype)},
+		{"compresslevel", RELOPT_TYPE_INT,
+		offsetof(BTOptions, compress) + offsetof(PageCompressOpts, compresslevel)},
+		{"compress_chunk_size", RELOPT_TYPE_INT,
+		offsetof(BTOptions, compress) + offsetof(PageCompressOpts, compress_chunk_size)},
+		{"compress_prealloc_chunks", RELOPT_TYPE_INT,
+		offsetof(BTOptions, compress) + offsetof(PageCompressOpts, compress_prealloc_chunks)}
 	};
 
 	return (bytea *) build_reloptions(reloptions, validate,
diff --git a/src/backend/access/spgist/spgutils.c b/src/backend/access/spgist/spgutils.c
index 2c661fcf96..b0a036f9f5 100644
--- a/src/backend/access/spgist/spgutils.c
+++ b/src/backend/access/spgist/spgutils.c
@@ -740,6 +740,14 @@ spgoptions(Datum reloptions, bool validate)
 {
 	static const relopt_parse_elt tab[] = {
 		{"fillfactor", RELOPT_TYPE_INT, offsetof(SpGistOptions, fillfactor)},
+		{"compresstype", RELOPT_TYPE_ENUM,
+		offsetof(SpGistOptions, compress) + offsetof(PageCompressOpts, compresstype)},
+		{"compresslevel", RELOPT_TYPE_INT,
+		offsetof(SpGistOptions, compress) + offsetof(PageCompressOpts, compresslevel)},
+		{"compress_chunk_size", RELOPT_TYPE_INT,
+		offsetof(SpGistOptions, compress) + offsetof(PageCompressOpts, compress_chunk_size)},
+		{"compress_prealloc_chunks", RELOPT_TYPE_INT,
+		offsetof(SpGistOptions, compress) + offsetof(PageCompressOpts, compress_prealloc_chunks)}
 	};
 
 	return (bytea *) build_reloptions(reloptions, validate,
diff --git a/src/backend/access/transam/xlogprefetcher.c b/src/backend/access/transam/xlogprefetcher.c
index 87d14210be..1c10a7a464 100644
--- a/src/backend/access/transam/xlogprefetcher.c
+++ b/src/backend/access/transam/xlogprefetcher.c
@@ -365,7 +365,7 @@ XLogPrefetcherAllocate(XLogReaderState *reader)
 {
 	XLogPrefetcher *prefetcher;
 	static HASHCTL hash_table_ctl = {
-		.keysize = sizeof(RelFileLocator),
+		.keysize = offsetof(RelFileLocator, compressOpt),
 		.entrysize = sizeof(XLogPrefetcherFilter)
 	};
 
@@ -869,6 +869,7 @@ XLogPrefetcherAddFilter(XLogPrefetcher *prefetcher, RelFileLocator rlocator,
 		/*
 		 * Don't allow any prefetching of this block or higher until replayed.
 		 */
+		filter->rlocator.compressOpt = rlocator.compressOpt;
 		filter->filter_until_replayed = lsn;
 		filter->filter_from_block = blockno;
 		dlist_push_head(&prefetcher->filter_queue, &filter->link);
diff --git a/src/backend/bootstrap/bootparse.y b/src/backend/bootstrap/bootparse.y
index 7d7655d295..79cbc3966c 100644
--- a/src/backend/bootstrap/bootparse.y
+++ b/src/backend/bootstrap/bootparse.y
@@ -210,6 +210,7 @@ Boot_CreateStmt:
 												   RELPERSISTENCE_PERMANENT,
 												   shared_relation,
 												   mapped_relation,
+												   (Datum) 0,
 												   true,
 												   &relfrozenxid,
 												   &relminmxid,
diff --git a/src/backend/catalog/heap.c b/src/backend/catalog/heap.c
index 9b03579e6e..f6eb82e58f 100644
--- a/src/backend/catalog/heap.c
+++ b/src/backend/catalog/heap.c
@@ -296,6 +296,7 @@ heap_create(const char *relname,
 			char relpersistence,
 			bool shared_relation,
 			bool mapped_relation,
+			Datum reloptions,
 			bool allow_system_table_mods,
 			TransactionId *relfrozenxid,
 			MultiXactId *relminmxid,
@@ -373,7 +374,8 @@ heap_create(const char *relname,
 									 shared_relation,
 									 mapped_relation,
 									 relpersistence,
-									 relkind);
+									 relkind,
+									 reloptions);
 
 	/*
 	 * Have the storage manager create the relation's disk file, if needed.
@@ -1280,6 +1282,7 @@ heap_create_with_catalog(const char *relname,
 							   relpersistence,
 							   shared_relation,
 							   mapped_relation,
+							   reloptions,
 							   allow_system_table_mods,
 							   &relfrozenxid,
 							   &relminmxid,
diff --git a/src/backend/catalog/index.c b/src/backend/catalog/index.c
index d7192f35e3..7a6f414bda 100644
--- a/src/backend/catalog/index.c
+++ b/src/backend/catalog/index.c
@@ -956,6 +956,7 @@ index_create(Relation heapRelation,
 								relpersistence,
 								shared_relation,
 								mapped_relation,
+								reloptions,
 								allow_system_table_mods,
 								&relfrozenxid,
 								&relminmxid,
diff --git a/src/backend/catalog/storage.c b/src/backend/catalog/storage.c
index d708af19ed..751320d749 100644
--- a/src/backend/catalog/storage.c
+++ b/src/backend/catalog/storage.c
@@ -91,7 +91,7 @@ AddPendingSync(const RelFileLocator *rlocator)
 	{
 		HASHCTL		ctl;
 
-		ctl.keysize = sizeof(RelFileLocator);
+		ctl.keysize = offsetof(RelFileLocator, compressOpt);
 		ctl.entrysize = sizeof(PendingRelSync);
 		ctl.hcxt = TopTransactionContext;
 		pendingSyncHash = hash_create("pending sync hash", 16, &ctl,
@@ -100,6 +100,7 @@ AddPendingSync(const RelFileLocator *rlocator)
 
 	pending = hash_search(pendingSyncHash, rlocator, HASH_ENTER, &found);
 	Assert(!found);
+	pending->rlocator.compressOpt = rlocator->compressOpt;
 	pending->is_truncated = false;
 }
 
@@ -588,7 +589,7 @@ SerializePendingSyncs(Size maxSize, char *startAddress)
 		goto terminate;
 
 	/* Create temporary hash to collect active relfilelocators */
-	ctl.keysize = sizeof(RelFileLocator);
+	ctl.keysize = offsetof(RelFileLocator, compressOpt);
 	ctl.entrysize = sizeof(RelFileLocator);
 	ctl.hcxt = CurrentMemoryContext;
 	tmphash = hash_create("tmp relfilelocators",
@@ -598,7 +599,11 @@ SerializePendingSyncs(Size maxSize, char *startAddress)
 	/* collect all rlocator from pending syncs */
 	hash_seq_init(&scan, pendingSyncHash);
 	while ((sync = (PendingRelSync *) hash_seq_search(&scan)))
-		(void) hash_search(tmphash, &sync->rlocator, HASH_ENTER, NULL);
+	{
+		RelFileLocator *rlocator;
+		rlocator = hash_search(tmphash, &sync->rlocator, HASH_ENTER, NULL);
+		rlocator->compressOpt = sync->rlocator.compressOpt;
+	}
 
 	/* remove deleted rnodes */
 	for (delete = pendingDeletes; delete != NULL; delete = delete->next)
diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index 7fbee0c1f7..74ea7328ad 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -16,11 +16,16 @@
 
 #include "access/attmap.h"
 #include "access/genam.h"
+#include "access/gin_private.h"
+#include "access/gist_private.h"
+#include "access/hash.h"
 #include "access/heapam.h"
 #include "access/heapam_xlog.h"
 #include "access/multixact.h"
+#include "access/nbtree.h"
 #include "access/reloptions.h"
 #include "access/relscan.h"
+#include "access/spgist_private.h"
 #include "access/sysattr.h"
 #include "access/tableam.h"
 #include "access/toast_compression.h"
@@ -14107,6 +14112,8 @@ ATExecSetRelOptions(Relation rel, List *defList, AlterTableType operation,
 	Datum		repl_val[Natts_pg_class];
 	bool		repl_null[Natts_pg_class];
 	bool		repl_repl[Natts_pg_class];
+	bytea		*byteaOpts;
+	PageCompressOpts *newPcOpts = NULL;
 	static char *validnsps[] = HEAP_RELOPT_NAMESPACES;
 
 	if (defList == NIL && operation != AT_ReplaceRelOptions)
@@ -14147,7 +14154,9 @@ ATExecSetRelOptions(Relation rel, List *defList, AlterTableType operation,
 		case RELKIND_RELATION:
 		case RELKIND_TOASTVALUE:
 		case RELKIND_MATVIEW:
-			(void) heap_reloptions(rel->rd_rel->relkind, newOptions, true);
+			byteaOpts = heap_reloptions(rel->rd_rel->relkind, newOptions, true);
+			if(byteaOpts)
+				newPcOpts = &((StdRdOptions *)byteaOpts)->compress;
 			break;
 		case RELKIND_PARTITIONED_TABLE:
 			(void) partitioned_table_reloptions(newOptions, true);
@@ -14157,7 +14166,35 @@ ATExecSetRelOptions(Relation rel, List *defList, AlterTableType operation,
 			break;
 		case RELKIND_INDEX:
 		case RELKIND_PARTITIONED_INDEX:
-			(void) index_reloptions(rel->rd_indam->amoptions, newOptions, true);
+			byteaOpts = index_reloptions(rel->rd_indam->amoptions, newOptions, true);
+			if(byteaOpts)
+			{
+				switch(rel->rd_rel->relam)
+				{
+					case BTREE_AM_OID:
+						newPcOpts = &((BTOptions *)byteaOpts)->compress;
+						break;
+
+					case HASH_AM_OID:
+						newPcOpts = &((HashOptions *)byteaOpts)->compress;
+						break;
+
+					case GIN_AM_OID:
+						newPcOpts = &((GinOptions *)byteaOpts)->compress;
+						break;
+
+					case GIST_AM_OID:
+						newPcOpts = &((GiSTOptions *)byteaOpts)->compress;
+						break;
+
+					case SPGIST_AM_OID:
+						newPcOpts = &((SpGistOptions *)byteaOpts)->compress;
+						break;
+
+					default:
+						break;
+				}
+			}
 			break;
 		default:
 			ereport(ERROR,
@@ -14201,6 +14238,26 @@ ATExecSetRelOptions(Relation rel, List *defList, AlterTableType operation,
 		}
 	}
 
+	/* check if changing page compression store format */
+	if(newPcOpts != NULL)
+	{
+		if(newPcOpts->compresstype != rel->rd_locator.compressOpt.algorithm)
+			ereport(ERROR,
+					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+					 errmsg("change compresstype parameter is not supported")));
+
+		if(rel->rd_locator.compressOpt.algorithm != PAGE_COMPRESSION_NONE &&
+			newPcOpts->compress_chunk_size != BLCKSZ / rel->rd_locator.compressOpt.chunks_pre_block)
+			ereport(ERROR,
+					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+					 errmsg("change compress_chunk_size parameter is not supported")));
+	}else{
+		if(rel->rd_locator.compressOpt.algorithm != PAGE_COMPRESSION_NONE)
+			ereport(ERROR,
+					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+					 errmsg("change compresstype parameter is not supported")));
+	}
+
 	/*
 	 * All we need do here is update the pg_class row; the new options will be
 	 * propagated into relcaches during post-commit cache inval.
diff --git a/src/backend/replication/basebackup.c b/src/backend/replication/basebackup.c
index 637c0ce459..d478b465b3 100644
--- a/src/backend/replication/basebackup.c
+++ b/src/backend/replication/basebackup.c
@@ -38,6 +38,7 @@
 #include "storage/dsm_impl.h"
 #include "storage/fd.h"
 #include "storage/ipc.h"
+#include "storage/page_compression.h"
 #include "storage/reinit.h"
 #include "utils/builtins.h"
 #include "utils/ps_status.h"
@@ -93,6 +94,8 @@ static void perform_base_backup(basebackup_options *opt, bbsink *sink);
 static void parse_basebackup_options(List *options, basebackup_options *opt);
 static int	compareWalFileNames(const ListCell *a, const ListCell *b);
 static bool is_checksummed_file(const char *fullpath, const char *filename);
+static bool is_compressed_datafile(const char *fullpath, const char *filename);
+static int	get_chunk_size_of_compressed_datafile(const char *pcd_filepath);
 static int	basebackup_read_file(int fd, char *buf, size_t nbytes, off_t offset,
 								 const char *filename, bool partial_read_ok);
 
@@ -1448,6 +1451,7 @@ is_checksummed_file(const char *fullpath, const char *filename)
 		strncmp(fullpath, "/", 1) == 0)
 	{
 		int			excludeIdx;
+		size_t		filenameLen;
 
 		/* Compare file against noChecksumFiles skip list */
 		for (excludeIdx = 0; noChecksumFiles[excludeIdx].name != NULL; excludeIdx++)
@@ -1461,12 +1465,99 @@ is_checksummed_file(const char *fullpath, const char *filename)
 				return false;
 		}
 
+		/*
+		 * Skip checksum check of compressed relation files. Compressed page
+		 * may be stored in multiple non-continuous chunks, and cannot perform
+		 * checksum while transferring data.
+		 */
+		filenameLen = strlen(filename);
+		if (filenameLen >= 4)
+		{
+			if (strncmp(filename + filenameLen - 4, "_pca", 4) == 0)
+				return false;
+		}
+
 		return true;
 	}
 	else
 		return false;
 }
 
+/*
+ * Check if the file is a page compression data file.
+ */
+static bool
+is_compressed_datafile(const char *fullpath, const char *filename)
+{
+	/* Check that the file is in a tablespace */
+	if (strncmp(fullpath, "./global/", 9) == 0 ||
+		strncmp(fullpath, "./base/", 7) == 0 ||
+		strncmp(fullpath, "/", 1) == 0)
+	{
+		size_t		filenameLen;
+
+		filenameLen = strlen(filename);
+		if (filenameLen >= 4)
+		{
+			if (strncmp(filename + filenameLen - 4, "_pcd", 4) == 0)
+				return true;
+		}
+
+		return false;
+	}
+	else
+		return false;
+}
+
+/**
+ * Get chunk size of a page compression data file,
+ * and return -1 if failed.
+*/
+static int
+get_chunk_size_of_compressed_datafile(const char *pcd_filepath)
+{
+	int			fd;
+	int			read_cnt;
+	size_t		filepath_len;
+	char		pca_filepath[MAXPGPATH];
+	PageCompressHeader pcheader;
+
+	/* setup pca file path */
+	filepath_len = strlen(pcd_filepath);
+	memcpy(pca_filepath, pcd_filepath, filepath_len + 1);
+	pca_filepath[filepath_len - 1] = 'a';
+
+	/* get chunk size from pca file */
+	fd = OpenTransientFile(pca_filepath, O_RDONLY | PG_BINARY);
+	if (fd < 0)
+	{
+		ereport(WARNING,
+				(errcode_for_file_access(),
+				 errmsg("could not open file \"%s\": %m", pca_filepath)));
+		return -1;
+	}
+
+	read_cnt = basebackup_read_file(fd,
+									(char *) &pcheader,
+									sizeof(PageCompressHeader),
+									0,
+									pca_filepath,
+									true);
+	CloseTransientFile(fd);
+
+	if (read_cnt != sizeof(PageCompressHeader))
+	{
+		ereport(WARNING,
+				(errcode_for_file_access(),
+				 errmsg("could not read file \"%s\": read only %d of %zu bytes",
+						pca_filepath, read_cnt, sizeof(PageCompressHeader))));
+		return -1;
+	}
+
+	return pcheader.chunk_size;
+}
+
+
 /*****
  * Functions for handling tar file format
  *
@@ -1504,6 +1595,9 @@ sendFile(bbsink *sink, const char *readfilename, const char *tarfilename,
 	char	   *segmentpath;
 	bool		verify_checksum = false;
 	pg_checksum_context checksum_ctx;
+	bool		verify_pcd_checksum = false;
+	int			chunk_size = 0;
+	uint32		chunkno = 1;
 
 	if (pg_checksum_init(&checksum_ctx, manifest->checksum_type) < 0)
 		elog(ERROR, "could not initialize checksum of file \"%s\"",
@@ -1549,6 +1643,23 @@ sendFile(bbsink *sink, const char *readfilename, const char *tarfilename,
 							(errmsg("invalid segment number %d in file \"%s\"",
 									segmentno, filename)));
 			}
+
+			/* Check if this's compressed data file */
+			if (is_compressed_datafile(readfilename, filename))
+			{
+				chunk_size = get_chunk_size_of_compressed_datafile(readfilename);
+				if (IsValidPageCompressChunkSize(chunk_size))
+				{
+					verify_pcd_checksum = true;
+				}
+				else
+				{
+					ereport(WARNING,
+							(errmsg("could not verify checksum in file \"%s\""
+									": invalid chunk size %d",
+									readfilename, chunk_size)));
+				}
+			}
 		}
 	}
 
@@ -1575,25 +1686,124 @@ sendFile(bbsink *sink, const char *readfilename, const char *tarfilename,
 		if (cnt == 0)
 			break;
 
-		/*
-		 * The checksums are verified at block level, so we iterate over the
-		 * buffer in chunks of BLCKSZ, after making sure that
-		 * TAR_SEND_SIZE/buf is divisible by BLCKSZ and we read a multiple of
-		 * BLCKSZ bytes.
-		 */
-		Assert((sink->bbs_buffer_length % BLCKSZ) == 0);
-
-		if (verify_checksum && (cnt % BLCKSZ != 0))
+		if (verify_pcd_checksum)
 		{
-			ereport(WARNING,
-					(errmsg("could not verify checksum in file \"%s\", block "
-							"%u: read buffer size %d and page size %d "
-							"differ",
-							readfilename, blkno, (int) cnt, BLCKSZ)));
-			verify_checksum = false;
+			/*
+			 * The checksums are verified at compressed chunk level, so we
+			 * iterate over the buffer in chunks of chunk_size, after making
+			 * sure that TAR_SEND_SIZE/buf is divisible by chunk_size and we
+			 * read a multiple of chunk_size bytes.
+			 */
+			Assert((sink->bbs_buffer_length % chunk_size) == 0);
+
+			if (cnt % chunk_size != 0)
+			{
+				ereport(WARNING,
+						(errmsg("could not verify checksum in file \"%s\", chunk "
+								"%u: read buffer size %d and chunk size %d "
+								"differ",
+								readfilename, chunkno, (int) cnt, chunk_size)));
+				verify_pcd_checksum = false;
+				verify_checksum = false;
+			}
+		}
+		else if (verify_checksum)
+		{
+			/*
+			 * The checksums are verified at block level, so we iterate over
+			 * the buffer in chunks of BLCKSZ, after making sure that
+			 * TAR_SEND_SIZE/buf is divisible by BLCKSZ and we read a multiple
+			 * of BLCKSZ bytes.
+			 */
+			Assert((sink->bbs_buffer_length % BLCKSZ) == 0);
+
+			if (verify_checksum && (cnt % BLCKSZ != 0))
+			{
+				ereport(WARNING,
+						(errmsg("could not verify checksum in file \"%s\", block "
+								"%u: read buffer size %d and page size %d "
+								"differ",
+								readfilename, blkno, (int) cnt, BLCKSZ)));
+				verify_checksum = false;
+			}
 		}
 
-		if (verify_checksum)
+		if (verify_pcd_checksum)
+		{
+			bool		chunk_retry = false;
+
+			for (i = 0; i < cnt / chunk_size; i++)
+			{
+				char	   *chunk;
+				PageCompressChunk *pcchunk;;
+
+				chunk = sink->bbs_buffer + chunk_size * i;
+				pcchunk = (PageCompressChunk *) chunk;
+				checksum = pg_checksum_compress_chunk(chunk, chunk_size, chunkno);
+				if (pcchunk->checksum != checksum)
+				{
+					/*
+					 * Retry the chunk on the first failure.  It's possible
+					 * that we read the part of the chunk just before postgres
+					 * updated the entire chunk so it ends up looking torn to
+					 * us.  We only need to retry once because the LSN should
+					 * be updated to something we can ignore on the next pass.
+					 * If the error happens again then it is a true validation
+					 * failure.
+					 */
+					if (chunk_retry == false)
+					{
+						int			reread_cnt;
+
+						/* Reread the failed chunk */
+						reread_cnt =
+							basebackup_read_file(fd,
+												 sink->bbs_buffer + chunk_size * i,
+												 chunk_size, len + chunk_size * i,
+												 readfilename,
+												 false);
+						if (reread_cnt == 0)
+						{
+							/*
+							 * If we hit end-of-file, a concurrent truncation
+							 * must have occurred, so break out of this loop
+							 * just as if the initial fread() returned 0.
+							 * We'll drop through to the same code that
+							 * handles that case. (We must fix up cnt first,
+							 * though.)
+							 */
+							cnt = chunk_size * i;
+							break;
+						}
+
+						/* Set flag so we know a retry was attempted */
+						chunk_retry = true;
+
+						/* Reset loop to validate the block again */
+						i--;
+						continue;
+					}
+
+					checksum_failures++;
+
+					if (checksum_failures <= 5)
+						ereport(WARNING,
+								(errmsg("checksum verification failed in "
+										"file \"%s\", chunk %u, blockno %u, chunkseq %u: calculated "
+										"%X but expected %X",
+										readfilename, chunkno, pcchunk->blockno, pcchunk->chunkseq,
+										checksum, pcchunk->checksum)));
+					if (checksum_failures == 5)
+						ereport(WARNING,
+								(errmsg("further checksum verification "
+										"failures in file \"%s\" will not "
+										"be reported", readfilename)));
+				}
+				chunk_retry = false;
+				chunkno++;
+			}
+		}
+		else if (verify_checksum)
 		{
 			for (i = 0; i < cnt / BLCKSZ; i++)
 			{
diff --git a/src/backend/storage/file/fd.c b/src/backend/storage/file/fd.c
index f904f60c08..503492eb82 100644
--- a/src/backend/storage/file/fd.c
+++ b/src/backend/storage/file/fd.c
@@ -89,6 +89,7 @@
 
 #include "access/xact.h"
 #include "access/xlog.h"
+#include "access/xlogutils.h"
 #include "catalog/pg_tablespace.h"
 #include "common/file_perm.h"
 #include "common/file_utils.h"
@@ -100,6 +101,7 @@
 #include "postmaster/startup.h"
 #include "storage/fd.h"
 #include "storage/ipc.h"
+#include "storage/page_compression.h"
 #include "utils/guc.h"
 #include "utils/resowner_private.h"
 
@@ -204,6 +206,8 @@ typedef struct vfd
 	/* NB: fileName is malloc'd, and must be free'd when closing the VFD */
 	int			fileFlags;		/* open(2) flags for (re)opening the file */
 	mode_t		fileMode;		/* mode to pass to open(2) */
+	bool		with_pcmap;		/* is page compression relation */
+	PageCompressHeader *pcmap;	/* memory map of page compression address file */
 } Vfd;
 
 /*
@@ -1223,6 +1227,17 @@ LruDelete(File file)
 
 	vfdP = &VfdCache[file];
 
+	if (vfdP->with_pcmap && vfdP->pcmap != NULL)
+	{
+		if (pc_munmap(vfdP->pcmap) != 0)
+			ereport(vfdP->fdstate & FD_TEMP_FILE_LIMIT ? LOG : data_sync_elevel(LOG),
+					(errcode_for_dynamic_shared_memory(),
+					 errmsg("could not munmap file \"%s\": %m",
+							vfdP->fileName)));
+
+		vfdP->pcmap = NULL;
+	}
+
 	/*
 	 * Close the file.  We aren't expecting this to fail; if it does, better
 	 * to leak the FD than to mess up our internal state.
@@ -1559,6 +1574,8 @@ PathNameOpenFilePerm(const char *fileName, int fileFlags, mode_t fileMode)
 	vfdP->fileSize = 0;
 	vfdP->fdstate = 0x0;
 	vfdP->resowner = NULL;
+	vfdP->with_pcmap = false;
+	vfdP->pcmap = NULL;
 
 	Insert(file);
 
@@ -1908,6 +1925,18 @@ FileClose(File file)
 
 	if (!FileIsNotOpen(file))
 	{
+		/* close the pcmap */
+		if (vfdP->with_pcmap && vfdP->pcmap != NULL)
+		{
+			if (pc_munmap(vfdP->pcmap) != 0)
+				ereport(vfdP->fdstate & FD_TEMP_FILE_LIMIT ? LOG : data_sync_elevel(LOG),
+						(errcode_for_dynamic_shared_memory(),
+						 errmsg("could not munmap file \"%s\": %m",
+								vfdP->fileName)));
+
+			vfdP->pcmap = NULL;
+		}
+
 		/* close the file */
 		if (close(vfdP->fd) != 0)
 		{
@@ -2266,6 +2295,105 @@ FileTruncate(File file, off_t offset, uint32 wait_event_info)
 	return returnCode;
 }
 
+/*
+ * initialize page compression memory map.
+ * While file_pcd is valid, will try to fix pca file in recovery mode.
+ */
+void
+SetupPageCompressMemoryMap(File file, File file_pcd, int chunk_size, uint8 algorithm)
+{
+	int			returnCode;
+	Vfd		   *vfdP;
+	PageCompressHeader *map;
+
+	Assert(FileIsValid(file));
+
+	vfdP = &VfdCache[file];
+
+	returnCode = FileAccess(file);
+	if (returnCode < 0)
+		ereport(ERROR,
+				(errcode_for_file_access(),
+				 errmsg("could not open file \"%s\": %m",
+						vfdP->fileName)));
+
+	map = pc_mmap(vfdP->fd, chunk_size, false);
+	if (map == MAP_FAILED)
+		ereport(ERROR,
+				(errcode_for_dynamic_shared_memory(),
+				 errmsg("could not mmap file \"%s\": %m",
+						vfdP->fileName)));
+
+	/* initialize page compression header */
+	if (map->chunk_size == 0 && map->algorithm == 0)
+	{
+		map->chunk_size = chunk_size;
+		map->algorithm = algorithm;
+
+		if (pc_msync(map) != 0)
+			ereport(data_sync_elevel(ERROR),
+					(errcode_for_dynamic_shared_memory(),
+					 errmsg("could not msync file \"%s\": %m",
+							vfdP->fileName)));
+	}
+
+	if (InRecovery && FileIsValid(file_pcd))
+	{
+		Vfd		   *vfdP_pcd = &VfdCache[file_pcd];
+
+		returnCode = FileAccess(file_pcd);
+		if (returnCode < 0)
+			ereport(ERROR,
+					(errcode_for_file_access(),
+					 errmsg("could not open file \"%s\": %m",
+							vfdP->fileName)));
+
+		check_and_repair_compress_address(map, chunk_size, algorithm, vfdP->fileName, vfdP_pcd->fd, vfdP_pcd->fileName);
+	}
+
+	vfdP->with_pcmap = true;
+	vfdP->pcmap = map;
+}
+
+/*
+ * Returns the page compression memory map.
+ *
+ */
+void *
+GetPageCompressMemoryMap(File file, int chunk_size)
+{
+	int			returnCode;
+	Vfd		   *vfdP;
+	PageCompressHeader *map;
+
+	Assert(FileIsValid(file));
+
+	vfdP = &VfdCache[file];
+
+	returnCode = FileAccess(file);
+	if (returnCode < 0)
+		ereport(ERROR,
+				(errcode_for_file_access(),
+				 errmsg("could not open file \"%s\": %m",
+						vfdP->fileName)));
+
+	Assert(vfdP->with_pcmap);
+
+	if (vfdP->pcmap == NULL)
+	{
+		map = pc_mmap(vfdP->fd, chunk_size, false);
+		if (map == MAP_FAILED)
+			ereport(ERROR,
+					(errcode_for_dynamic_shared_memory(),
+					 errmsg("could not mmap file \"%s\": %m",
+							vfdP->fileName)));
+
+		vfdP->pcmap = map;
+	}
+
+	return vfdP->pcmap;
+}
+
 /*
  * Return the pathname associated with an open file.
  *
diff --git a/src/backend/storage/smgr/Makefile b/src/backend/storage/smgr/Makefile
index 596b564656..ba7a9aad35 100644
--- a/src/backend/storage/smgr/Makefile
+++ b/src/backend/storage/smgr/Makefile
@@ -14,6 +14,7 @@ include $(top_builddir)/src/Makefile.global
 
 OBJS = \
 	md.o \
-	smgr.o
+	smgr.o \
+	page_compression.o
 
 include $(top_srcdir)/src/backend/common.mk
